#include <IRremote.h>


int RECV_PIN = 11;
int STATUS_PIN = 13;
boolean record = false;
int codeType = -1; 
unsigned long codeValue;
unsigned int rawCodes[RAWBUF]; 
int codeLen; 
int toggle = 0; 

IRrecv irrecv(RECV_PIN);
IRsend irsend;

decode_results results;

void setup()
{
  Serial.begin(115200);
  Serial.setTimeout(50);

  irrecv.enableIRIn(); 
  pinMode(STATUS_PIN, OUTPUT);
}






void loop() {
  String a = "";
  if(Serial.available()){
    a= Serial.readString();
  }
  if (a.startsWith("send!")) {
    codeType = a.substring(a.indexOf("!") + 1, a.indexOf("@")).toInt();
    codeLen = a.substring(a.indexOf("?") + 1).toInt();
    if(codeType != -1){
      codeValue = a.substring(a.indexOf("@") + 1, a.indexOf("?")).toInt();
      
    }else{
      for(int i = 0; i < codeLen; i ++){
        rawCodes[i] = a.substring(a.indexOf("@") + 1, a.indexOf(" ")).toInt();
        a = a.substring(a.indexOf(" ") + 1);
      }
    }
    
    digitalWrite(STATUS_PIN, HIGH);
    sendCode(false);
    digitalWrite(STATUS_PIN, LOW);
    irrecv.enableIRIn();
    delay(50); 
   
  } else if(a == "recv\n"){
       record = true;
  }
  else if (irrecv.decode(&results)) {
    String toSend = "";
    digitalWrite(STATUS_PIN, HIGH);
    storeCode(&results);
    irrecv.resume(); 
    digitalWrite(STATUS_PIN, LOW);
    if(record){
      toSend += String(codeType);
      toSend += "@";
      int i;
      if(codeType == UNKNOWN){
        for (i = 0; i < codeLen; i = i + 1) {
          toSend += String(rawCodes[i]);
          toSend +=" ";
        }
      }else{
        toSend += String(codeValue);
      }
      toSend += "?";
      toSend += String(codeLen);
      Serial.println(toSend);
    }
    record = false;
  }
}
void storeCode(decode_results *results) {
  codeType = results->decode_type;
  int count = results->rawlen;
  if (codeType == UNKNOWN) {
    codeLen = results->rawlen - 1;
    for (int i = 1; i <= codeLen; i++) {
      if (i % 2) {
        rawCodes[i - 1] = results->rawbuf[i]*USECPERTICK - MARK_EXCESS;
      } 
      else {
        rawCodes[i - 1] = results->rawbuf[i]*USECPERTICK + MARK_EXCESS;
      }
    }
  }
  else {
    if (codeType == NEC) {
      if (results->value == REPEAT) {
        return;
      }
    } 
    codeValue = results->value;
    codeLen = results->bits;
  }
}

void sendCode(int repeat) {
  if (codeType == NEC) {
    if (repeat) {
      irsend.sendNEC(REPEAT, codeLen);
    } 
    else {
      irsend.sendNEC(codeValue, codeLen);
    }
  } 
  else if (codeType == SONY) {
    irsend.sendSony(codeValue, codeLen);
  } 
  else if (codeType == PANASONIC) {
    irsend.sendPanasonic(codeValue, codeLen);
  }
  else if (codeType == JVC) {
    irsend.sendJVC(codeValue, codeLen, false);
  }else if( codeType == SAMSUNG){
    irsend.sendSAMSUNG(codeValue, codeLen);
  }else if(codeType == WHYNTER){
    irsend.sendWhynter(codeValue, codeLen);
  }else if(codeType == LG){
    irsend.sendLG(codeValue, codeLen);
  }else if(codeType == DENON){
    irsend.sendDenon(codeValue, codeLen);
  }
  else if (codeType == RC5 || codeType == RC6) {
    if (!repeat) {
      toggle = 1 - toggle;
    }
    codeValue = codeValue & ~(1 << (codeLen - 1));
    codeValue = codeValue | (toggle << (codeLen - 1));
    if (codeType == RC5) {
      irsend.sendRC5(codeValue, codeLen);
    } 
    else {
      irsend.sendRC6(codeValue, codeLen);
    }
  } 
  else if (codeType == UNKNOWN /* i.e. raw */) {
    for (int i = 1; i <= codeLen; i++) {
      if (i % 2) {
        Serial.print(" m");
      } 
      else {
       Serial.print(" s");
      }
     Serial.print(rawCodes[i - 1], DEC);
    }
    irsend.sendRaw(rawCodes, codeLen, 38);
  }
}
